﻿Public Class form1
    Inherits System.Windows.Forms.Form
    Private Const URL_MESSAGE As String = "mspsoft . com"
    Private Const DIR_MESSAGE As String = "c:\"
    Private WithEvents _Downloader As WebFileDownloader
    Dim x As Boolean

#Region " Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()
        InitializeComponent()
    End Sub
#End Region
    
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Public Shared Sub Main()
        Application.EnableVisualStyles()
        Application.DoEvents()
        Application.Run(New form1)
        Application.Exit()
    End Sub
    Private Sub textbox1_GotFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.GotFocus
        If TextBox1.Text = URL_MESSAGE Then TextBox1.Text = String.Empty
    End Sub
    Private Sub txtURL_LostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.LostFocus
        If TextBox1.Text = String.Empty Then TextBox1.Text = URL_MESSAGE
    End Sub
    Private Sub textbox2_GotFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox2.GotFocus
        If TextBox2.Text = DIR_MESSAGE Then TextBox2.Text = String.Empty
    End Sub
    Private Sub textbox2_LostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox2.LostFocus
        If TextBox2.Text = String.Empty Then TextBox2.Text = DIR_MESSAGE
    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        x = True
        End
    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        If Not IO.Directory.Exists(TextBox2.Text) Then
            MessageBox.Show("مسیر ذخیره فایلهای دانلود اشتباه میباشد لطفا دوباره چک کنید.", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        Try
            _Downloader = New WebFileDownloader
            _Downloader.DownloadFileWithProgress(TextBox1.Text, TextBox2.Text.TrimEnd("\"c) & GetFileNameFromURL(TextBox1.Text))
        Catch ex As Exception
            MessageBox.Show("خطا: " & ex.Message)
        End Try

    End Sub
    Private Function GetFileNameFromURL(ByVal URL As String) As String
        If URL.IndexOf("/"c) = -1 Then Return String.Empty

        Return "\" & URL.Substring(URL.LastIndexOf("/"c) + 1)
    End Function
    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If FolderBrowserDialog1.ShowDialog(Me) <> DialogResult.Cancel Then
            TextBox2.Text = FolderBrowserDialog1.SelectedPath
        End If
    End Sub
    Private Sub _Downloader_FileDownloadSizeObtained(ByVal iFileSize As Long) Handles _Downloader.FileDownloadSizeObtained
        ProgressBar1.Value = 0
        ProgressBar1.Maximum = Convert.ToInt32(iFileSize)
    End Sub
    Private Sub _Downloader_FileDownloadComplete() Handles _Downloader.FileDownloadComplete
        ProgressBar1.Value = ProgressBar1.Maximum
        MessageBox.Show("دانلود فایل کامل شد")
    End Sub
    Private Sub _Downloader_FileDownloadFailed(ByVal ex As System.Exception) Handles _Downloader.FileDownloadFailed
        MessageBox.Show("دانلود با خطا روبرو شد: " & ex.Message)
    End Sub
    Private Sub _Downloader_AmountDownloadedChanged(ByVal iNewProgress As Long) Handles _Downloader.AmountDownloadedChanged
        ProgressBar1.Value = Convert.ToInt32(iNewProgress)
        lblProgress.Text = WebFileDownloader.FormatFileSize(iNewProgress) & " of " & WebFileDownloader.FormatFileSize(ProgressBar1.Maximum) & " downloaded"
        Application.DoEvents()
    End Sub

    Private Sub form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lblProgress.Text = String.Empty
        TextBox1.Text = URL_MESSAGE
        TextBox2.Text = DIR_MESSAGE
        Show()
        Button3.Focus()

    End Sub
    Private Sub LinkLabel1_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs)

    End Sub
End Class

